﻿using System;
using System.Collections.Generic;
using System.Net.Mime;
using System.Security.Cryptography;
using System.Text;
using System.Xml;
using System.Security.Cryptography;
using System.Security.Cryptography.Xml;

namespace RSA
{
    public class RSAXMLDemo
    {
        public static string EncryptXML(string strXML)
        {
            // 创建一个用于加密密钥的非对称密钥
            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
            // 加载一个公开密钥
            XmlDocument pubKeys = new XmlDocument();
            pubKeys.Load("publickey.xml");
            // 使用公开密钥加密密钥
            rsa.FromXmlString(pubKeys.OuterXml);

            // xml文档
            XmlDocument xmlEncDoc = new XmlDocument();
            //xmlEncDoc.Load("testData.xml");
            xmlEncDoc.LoadXml(strXML);
            XmlElement encElement = xmlEncDoc.SelectSingleNode("/root/creditcard/number") as XmlElement;

            // 完成加密xml的类
            EncryptedXml xmlEnc = new EncryptedXml(xmlEncDoc);
            
            // 增加一个“body”密钥，使用rsa编码
            xmlEnc.AddKeyNameMapping("body", rsa);
            // 使用“session”密钥来加密数据
            // 这些信息被保存在KeyInfo元素下
            EncryptedData encData = xmlEnc.Encrypt(encElement, "body");
            // 用加密后的元素替换初始元素
            EncryptedXml.ReplaceElement(encElement, encData, false);

            xmlEncDoc.Save("testData2.xml");
            return xmlEncDoc.InnerXml;

        }

        public static string DescryptXML(string strXML)
        {
            // 创建一个用于解密密钥的非对称密钥
            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
            // 加载私有密钥
            XmlDocument privKeys = new XmlDocument();
            privKeys.Load("privatekey.xml");
            // 使用私有密钥来解密密钥
            rsa.FromXmlString(privKeys.OuterXml);

            XmlDocument xmlEncDoc = new XmlDocument();
            //xmlEncDoc.Load("testData2.xml");
            xmlEncDoc.LoadXml(strXML);

            // 增加一个密钥名称并映射到被加密的文档中
            EncryptedXml encXml = new EncryptedXml(xmlEncDoc);
            encXml.AddKeyNameMapping("body", rsa);

            // 解密所有<EncryptedData>元素
            encXml.DecryptDocument();

            xmlEncDoc.Save("testData3.xml");
            return xmlEncDoc.InnerXml;
        }
    }
}
